<?php

/*
|---------------------------------------------------------------------------|
| Max Media Manager v0.1                                                    |
| =================                                                         |
|                                                                           |
| Copyright (c) 2003-2004 Awarez Ltd.                                       |
| For contact details, see: http://www.awarez.net/                          |
|                                                                           |
| Copyright (c) 2000-2003 the phpAdsNew developers                          |
| For contact details, see: http://www.phpadsnew.com/                       |
|                                                                           |
| This program is free software; you can redistribute it and/or modify      |
| it under the terms of the GNU General Public License as published by      |
| the Free Software Foundation; either version 2 of the License, or         |
| (at your option) any later version.                                       |
|                                                                           |
| This program is distributed in the hope that it will be useful,           |
| but WITHOUT ANY WARRANTY; without even the implied warranty of            |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
| GNU General Public License for more details.                              |
|                                                                           |
| You should have received a copy of the GNU General Public License         |
| along with this program; if not, write to the Free Software               |
| Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA |
|---------------------------------------------------------------------------|
$Id: adclick.php 291 2004-06-01 16:29:11Z andrew $
*/

// Figure out our location
define ('phpAds_path', '.');

/*********************************************************/
/* Include required files                                */
/*********************************************************/

require	(phpAds_path."/config.inc.php");
require_once (phpAds_path."/libraries/lib-io.inc.php");
require (phpAds_path."/libraries/lib-db.inc.php");

if ($phpAds_config['log_adclicks'])
{
    require (phpAds_path."/libraries/lib-remotehost.inc.php");
    require (phpAds_path."/libraries/lib-log.inc.php");
}



/*********************************************************/
/* Register input variables                              */
/*********************************************************/

phpAds_registerGlobal (
                        'bannerid',
                        'bannerID',
                        'n',
                        'log',
                        'zoneid',
                        'source',
                        'dest',
                        'ismap',
                        'ct0'
                      );



/*********************************************************/
/* Main code                                             */
/*********************************************************/

// Determine the user ID
$userid = phpAds_getUniqueUserID();
phpAds_setCookie("phpAds_id", $userid, time()+365*24*60*60);


if (!isset($bannerid) && isset($bannerID)) {
    $bannerid = $bannerID;
}

if (!isset($n)) {
    $n = 'default';
}


// Fetch BannerID
if (!isset($bannerid)) {
    
    // Bannerid and destination not known, try to get values from the phpAds_banner cookie.
    if (isset($HTTP_COOKIE_VARS['phpAds_banner'][$n]) && $HTTP_COOKIE_VARS['phpAds_banner'][$n] != 'DEFAULT') {
        
        $cookie = unserialize (stripslashes($HTTP_COOKIE_VARS['phpAds_banner'][$n]));
        
        if (isset($cookie['bannerid'])) {
            $bannerid = addslashes($cookie['bannerid']);
        } else {
            $bannerid = 'DEFAULT';
        }
        
        if (isset($cookie['zoneid'])) {
            $zoneid = addslashes($cookie['zoneid']);
        }
        
        if (isset($cookie['source'])) {
            $source = addslashes($cookie['source']);
        }
        
        if (isset($cookie['dest'])) {
            $dest =addslashes($cookie['dest']);
        }
        
    } else {
        $bannerid = "DEFAULT";
    }
}


// Get destination URL
if (isset($ct0) && $ct0 != '') {                             // If ct0 is set, then redirect to a 3rd party server...

    $url = $ct0;
    
} else if (isset($dest) && $dest != '') {                    // Otherwise check for destination specified in tag

    $url = stripslashes($dest);
    
} else if (phpAds_dbConnect()) {
    
    if ($bannerid != "DEFAULT") {
        
        // Get target URL and CampaignID
        $res = phpAds_dbQuery("
                        			SELECT
                        				url, campaignid
                        			FROM
                        				".$phpAds_config['tbl_banners']."
                        			WHERE
                        				bannerid = ".$bannerid);
        
        $url 	    = phpAds_dbResult($res, 0, 0);
        $campaignid = phpAds_dbResult($res, 0, 1);
    }
    
} else {
    
    if (!defined('LIBVIEWCACHE_INCLUDED')) {
        include (phpAds_path.'/libraries/deliverycache/cache-'.$phpAds_config['delivery_caching'].'.inc.php');
    }
    
    if (isset($zoneid)) {
        
        if ($zoneid != 0) {
            
            $cacheid = 'what=zone:'.$zoneid;
            $cache   = phpAds_cacheFetch ($cacheid);
            
            // extract cache
            list ($zoneid, $rows, $what, $prioritysum, $chain, $prepend, $append) = $cache;
            
        } else {
            
            //assume...
            $clientid   = 0;
            $campaignid = 0;
            $what       = $bannerid;
            
            $cacheid = 'what='.$what.'&clientid='.$clientid.'&campaignid='.$campaignid.'&remaining=true';
            $cache = phpAds_cacheFetch ($cacheid);
            
            // extract cache
            list ($rows, $what, $prioritysum) = $cache;
            
        }
        
        // scan through array to find banner and url, then redirect
        foreach ($rows as $row) {
            if ($row['bannerid'] == $bannerid) {
                $url = $row['url'];
                header ("Location: ".$url);
                exit;
            }
        }
        
        
    } else {
        // no cache...
        $cache = false;
    }
}


// If zoneid is not set, log it as a regular banner
if (!isset($zoneid) || strlen($zoneid)==0) {
    $zoneid = 0;
}

// Derive the source
if (isset($source)) {
    $source = phpAds_deriveSource($source);
} else {
    $source = '';
}

// Get vars so that we can pass them to the next call
if (isset($HTTP_GET_VARS)) {
    for (reset ($HTTP_GET_VARS); $key = key($HTTP_GET_VARS); next($HTTP_GET_VARS)) {
        if ($key != 'bannerid' &&
        $key != 'cb' &&
        $key != 'dest' &&
        $key != 'ismap' &&
        $key != 'log' &&
        $key != 'n' &&
        $key != 'source' &&
        $key != 'zoneid'&&
        $key != 'ct0')
        $vars[] = $key.'='.$HTTP_GET_VARS[$key];
    }
}

if (isset($HTTP_POST_VARS)) {
    for (reset ($HTTP_POST_VARS); $key = key($HTTP_POST_VARS); next($HTTP_POST_VARS)) {
        if ($key != 'bannerid' &&
        $key != 'cb' &&
        $key != 'dest' &&
        $key != 'ismap' &&
        $key != 'log' &&
        $key != 'n' &&
        $key != 'source' &&
        $key != 'zoneid'&&
        $key != 'ct0')
        $vars[] = $key.'='.$HTTP_POST_VARS[$key];
    }
}

// Log clicks
if (!phpAds_isClickBlocked($bannerid)) {
    
    if ($phpAds_config['log_adclicks']) {
        phpAds_logClick($userid, $bannerid, $zoneid, $source);
    }
    
    // Send block cookies
    phpAds_updateClickBlockTime($bannerid);
    phpAds_flushCookie ();
}

if (isset($ct0) && $ct0 != '') {                              // If ct0 is set, then redirect to a 3rd party server...
    header ("Location: ".$ct0);
    exit;
} else if (isset($dest) && $dest != '') {                     // Otherwise redirect as usual
    $url = $dest;
}

if (isset($vars) && is_array($vars) && sizeof($vars) > 0) {
    if (strpos ($url, '?') > 0) {
        $url = $url.'&'.implode ('&', $vars);
    } else {
        $url = $url.'?'.implode ('&', $vars);
    }
}

// ISMAP click location
if (isset($ismap) && $ismap != '') {
    $url .= $ismap;
}



// Redirect
if (isset($url) && $url != '') {
    header ("Location: ".$url);
    exit;
} else if ($phpAds_config['default_banner_target'] != '') {
    header ("Location: ".$phpAds_config['default_banner_target']);
    exit;
} else {
    // No URL found, redirect to the original page
    if (isset($HTTP_SERVER_VARS['HTTP_REFERER'])) {
        header ("Location: ".$HTTP_SERVER_VARS['HTTP_REFERER']);
        exit;
    }
}

?>